# CreateDnatEntry

## 1. API Description

This API (CreateDnatEntry) is used to create a DNAT rule.

{% hint style="info" %} <mark style="color:blue;">**Note**</mark>

<mark style="color:blue;">By default, you can create up to 100 DNAT rules for a NAT gateway. For additional quota, please contact us.</mark>
{% endhint %}

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name | Required | Type                                                                                                         | Description                                                                                    |
| -------------- | -------- | ------------------------------------------------------------------------------------------------------------ | ---------------------------------------------------------------------------------------------- |
| natGatewayId   | Yes      | String                                                                                                       | NAT gateway ID.                                                                                |
| eipId          | Yes      | String                                                                                                       | The elastic IP ID configured in the DNAT rule.                                                 |
| privateIp      | Yes      | String                                                                                                       | The private IP address configured in the DNAT rule.                                            |
| protocol       | Yes      | [DnatEntryProtocol](https://docs.console.zenlayer.com/api-reference/compute/datastructure#dnatentryprotocol) | The protocol type configured in the DNAT rule.                                                 |
| listenerPort   | No       | String                                                                                                       | <p>The public port or port range forwarded by the DNAT rule.</p><p>Valid values: 1–65535.</p>  |
| internalPort   | No       | String                                                                                                       | <p>The private port or port range forwarded by the DNAT rule.</p><p>Valid values: 1–65535.</p> |

## 3. Output Parameters

| Parameter Name | Type   | Description                                                                                                           |
| -------------- | ------ | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |
| dnatEntryId    | String | The unique ID of the DNAT rule.                                                                                       |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Create a DNAT entry.**

```json
POST /api/v2/zec HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: CreateDnatEntry
<Common Request Params>

Request：
{
    "natGatewayId": "<natGatewayId>",
    "eipId": "<eipId>",
    "privateIp": "10.0.0.2",
    "protocol": "TCP",
    "listenerPort": "1-30",
    "internalPort": "1-30"
}

Response：
{
  "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3",
  "response": {
    "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3",
    "dnatEntryId": "<dnatEntryId>"
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](https://docs.console.zenlayer.com/api-reference/api-introduction/toolkit/api-sdk)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](https://docs.console.zenlayer.com/api-reference/api-introduction/instruction/commonerrorcode).

| HTTP Status Code | Error Code                                   | Description                                       |
| ---------------- | -------------------------------------------- | ------------------------------------------------- |
| 404              | INVALID\_NAT\_NOT\_FOUND                     | NAT gateway does not exist.                       |
| 400              | OPERATION\_DENIED\_NAT\_STATUS               | NAT gateway state is not RUNNING.                 |
| 404              | INVALID\_EIP\_NOT\_FOUND                     | Elastic IP does not exist.                        |
| 400              | OPERATION\_DENIED\_EIP\_NOT\_ASSIGNED        | Elastic IP is not bound.                          |
| 400              | OPERATION\_DENIED\_EIP\_NOT\_ASSIGN\_NAT     | The elastic IP isn't assigned to the NAT gateway. |
| 400              | OPERATION\_DENIED\_DNAT\_ENTRY\_COUNT\_LIMIT | The number of DNAT entries is limited.            |
